#include <stdio.h>
#include <upc.h>
#include <upc_collective.h>


shared double cc[THREADS];
shared double *res;

int main () {
  cc[MYTHREAD] = (double) MYTHREAD + 1.0;
  res = (shared double *) upc_all_alloc(1, sizeof(double));
  upc_all_reduceD(res,cc,UPC_ADD,THREADS,1,
                  NULL,UPC_IN_ALLSYNC | UPC_OUT_ALLSYNC);

  upc_barrier;
  printf("Thread %i: %12.4f\n",MYTHREAD, (double) *res);
  if (MYTHREAD == 0) upc_free(res);

}
