
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"
#include "upcnpb.h"

void exchange_6(double g[],int jbeg,int jfin1) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   compute the right hand side based on exact solution
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  input parameters
//---------------------------------------------------------------------
#define g(i,j) g[(i)+(ISIZ2+2)*(j)]

//---------------------------------------------------------------------
//  local parameters
//---------------------------------------------------------------------
      int k;

      int ptr;



//---------------------------------------------------------------------
//   communicate in the east and west directions
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   send west
//---------------------------------------------------------------------
      if (jbeg==1) {
        ptr = wptr(4);
        ll_buffer = (double *)&u_buffer(node,ptr);
        ptr = 0;
        for (k = 1; k <= nz; k++) {
          ll_buffer(ptr + k) = g(1,k);
        }

      }

      upc_barrier;

//---------------------------------------------------------------------
//   receive from east
//---------------------------------------------------------------------
      if (jfin1==ny) {

        ptr = wptr(4);
        upc_memget(ul_buffer, &u_buffer(east,ptr),
                   sizeof(double)*nz);
        ptr = 0;
        for (k = 1; k <= nz; k++) {
          g(ny+1,k) = ul_buffer(ptr + k);
        }

      }

      return;
#undef g
}
